/* library.h file*/

#include <sys/types.h>
#include <sys/stat.h>
#include "errno.h"
#include "io.h"
#include "fcntl.h"
#include "dos.h"
#include "dir.h"
#include "stdio.h"
#include "string.h"
#include "stdlib.h"
#include "ctype.h"
#include "time.h"
#include "stddef.h"
#include "process.h"
#include "share.h"
#include "alloc.h"
#include "stdarg.h"
#include "conio.h"
#include "setjmp.h"


#define BACKSPACE    "\b \b"

typedef unsigned       bit;
typedef unsigned int  word;
typedef unsigned char byte;
typedef unsigned long ulong;

/*=====================================================================*/
/* FOSSIL definitions                                                  */
/*=====================================================================*/

#define SETBAUD    0
#define TRANSWAIT  1
#define RECVWAIT   2
#define GETSTAT    3
#define INIT       4
#define DEINIT     5
#define DTR        6
  #define UP         1
  #define DOWN       0
#define FLUSHOUT   8
#define PURGEOUT   9
#define PURGEIN    10
#define TRANSMIT   11
#define PEEK       12
#define KEYNOWAIT  13
#define KEYWAIT    14
#define FLOW       15
#define ONOFF      16
  #define ON         0
  #define OFF        2
#define SETCRSR    17
#define READCRSR   18
#define ONEANSI    19
  #define CARRIER    128
  #define INITOK     0x1954
#define WATCHDOG   20
#define REBOOT     23
  #define COLD       0
  #define WARM       1
#define BLOCKREAD  24
#define BLOCKWRITE 25


/* Symbols for SPAWNIT */

#define SPAWN 0;
#define EXEC  1;
#define BATCH 2;
#define DOS   3;
#define EXIT  4;
#define PRINT 5;

/* Symbols for GENIN */

#define ALLL     1
#define ALPHA    2
#define NUM      3
#define ALPHANUM 4
#define YESNO    5
#define FLE      6
#define FLEP     7
#define FLEW     8
#define FLEPW    9
#define NAME     10
#define NEAT     11
#define PHONE    12
#define DATE     13
#define SUBJECT  14
#define YESNOM   15
#define FLEX     16
#define ARROWS   17
#define ANSIIN   18
#define ANSISET  19
#define FBATCH   20
#define FBATCHW  21
#define FBATCHWP 22
#define FBATCHP  23
#define TRUEANSI 24
#define WORD 	 25
#define WORDNUM	 26
#define HYPER	 30
#define FLENX	 64
#define YESNOQ   65

struct fdate {
  bit day:   5;
  bit month: 4;
  bit year:  7;
};
union df {
  struct fdate fd;
  int x;
};
struct ftme {
  bit sec:  5;
  bit min:  6;
  bit hour: 5;
};
union tf {
  struct ftme ft;
  int x;
};

extern void pascal (*pause_mtask)(void);
extern void pascal set_mtask(void);
extern void pascal my_sleep(int secs);

/***********************************/
/* functions in ansi.c (low-level) */
/***********************************/

#ifdef __TURBOC__
  #define _fastcall pascal
#endif

/* NOTE:  all screen output except for status line should go (ultimately)
 * through ansi_out().
 */
int _fastcall  ansi_out (char *buf);
void _fastcall set_screensize (int reservedlines);
void _fastcall put_char (char c,char attr,int x,int y);
void _fastcall pos_hardcursor (int x,int y);
void _fastcall hardcursor_off (void);
void _fastcall hardcursor_on (int x,int y);
void _fastcall scroll_up (int tx,int ty,int bx,int by,char attr);
void _fastcall clearwindow (int tx,int ty,int bx,int by,char attr);
void _fastcall cleartoeol (int x,int y,int ex,char attr);
void _fastcall validate_cursor (void);


extern int    maxx,maxy;
extern int    realmaxx,realmaxy;
#ifndef OS2
 extern int    usebios;
#endif
extern int    useansi;
extern int    tabspaces;

/* END OF FILE: library.h */
